#include "filter_for_plugin_description.h"

// If use this macro, the basic plugin information will be exported
//      <cache_info>
//          <plugin_name>Plugin Description Filter Plugin</plugin_name>
//          <plugin_checksum/>
//      </cache_info>
//      <debug>false</debug>
//      <versions>
//          <version>
//              <name>adtf</name>
//              <major>3</major>
//              <minor>999</minor>
//              <patch>999</patch>
//              <description>TODO!</description>
//          </version>
//          <version>
//              <name>adtf::ucom</name>
//              <major>3</major>
//              <minor>1</minor>
//              <patch>0</patch>
//              <description>TODO!</description>
//          </version>
//      </versions>
ADTF_PLUGIN("Plugin Description Filter Plugin",
            cPluginDescriptionFilter);

cPluginDescriptionFilter::cPluginDescriptionFilter()
{
    // This will generate the description for the pins:
    //      <pin_descriptions>
    //          <pin_description>
    //              <name>in</name>
    //              <streamtype_description>
    //                  <metatype_name>adtf/plaintype</metatype_name>
    //                  <property_descriptions>
    //                      <property_description>
    //                          <name>c-type</name>
    //                          <type>cString</type>
    //                          <value>FLOAT32</value>
    //                          <list/>
    //                      </property_description>
    //                      <property_description>
    //                          <name>md_definitions</name>
    //                          <type>cString</type>
    //                          <value>&lt; struct name = "plain" alignment = "1" version = "1"&gt; &lt; element name = "value" arraysize = "1" type = "tFloat32"&gt; &lt; deserialized alignment = "1" / &gt; &lt; serialized bytepos = "0" byteorder = "LE" / &gt; &lt; / element & gt; (&lt; / struct&gt; < / value>
    //                          <list/>
    //                      </property_description>
    //                      <property_description>
    //                          <name>md_struct</name>
    //                          <type>cString</type>
    //                          <value>plain</value>
    //                          <list/>
    //                      </property_description>
    //                      </property_descriptions>
    //              </streamtype_description>
    //              <direction>1</direction>
    //              <description>This is the input that is processed.</description>
    //          </pin_description>
    //          <pin_description>
    //              <name>out</name>
 //              <streamtype_description>
    //                  <metatype_name>adtf/plaintype</metatype_name>
    //                  <property_descriptions>
    //                      <property_description>
    //                          <name>c-type</name>
    //                          <type>cString</type>
    //                          <value>FLOAT32</value>
    //                          <list/>
    //                      </property_description>
    //                      <property_description>
    //                          <name>md_definitions</name>
    //                          <type>cString</type>
    //                          <value>&lt; struct name = "plain" alignment = "1" version = "1"&gt; &lt; element name = "value" arraysize = "1" type = "tFloat32"&gt; &lt; deserialized alignment = "1" / &gt; &lt; serialized bytepos = "0" byteorder = "LE" / &gt; &lt; / element & gt; (&lt; / struct&gt; < / value>
    //                          <list/>
    //                      </property_description>
    //                      <property_description>
    //                          <name>md_struct</name>
    //                          <type>cString</type>
    //                          <value>plain</value>
    //                          <list/>
    //                      </property_description>
    //                      </property_descriptions>
    //              </streamtype_description>
    //              <direction>1</direction>
    //              <description>This is the output that is generated.</description>
    //          </pin_description>
    //      </pin_descriptions>
    m_pReader = CreateInputPin("in", stream_type_plain<float>(), true);
    SetDescription("in", "This is the input that is processed.");

    m_pWriter = CreateOutputPin("out", stream_type_plain<float>());
    SetDescription("out", "This is the output that is generated.");

    // This will generate the description for the properties:
    //      <property_descriptions>
    //          <property_description>
    //              <name>float_property</name>
    //                  <type>double</type>
    //                  <value>3.141500</value>
    //                  <list/>
    //          </property_description>
    //          <property_description>
    //              <name>string_property</name>
    //              <type>cString</type>
    //              <value>i am a string</value>
    //              <list/>
    //          </property_description>
    //      </property_descriptions>
    m_fFloatProperty.SetDescription("Use this property to set some float values.");
    RegisterPropertyVariable("float_property", m_fFloatProperty);
    m_strProperty.SetDescription("Use this property to set a string.");
    RegisterPropertyVariable("string_property", m_strProperty);

    // This will generate the description for the component:
    //      <description>Use this filter to show how the plugin description works.</description>
    SetDescription("This filter shows the mapping of filter code to plugindescription.");

    // This will generate the description for the component:
    //      <help_link>path/to/documentation.html</help_link>
    SetHelpLink("path/to/documentation.html");

    // This will generate the description for a filter editor:
    //  <editor_descriptions>
    //      <editor_description>
    //          <name>Edit with fancy Filter Editor</name>
    //          <url>fancy_filter_editor.qml</url>
    //      </editor_description>
    //  </editor_descriptions>
    SetEditor("Edit with fancy Filter Editor", "fancy_filter_editor.qml");
}


